function [longi,latit,imagemsg]=plotimageMSG(yyyy, mm, dd,timestep,lonmin,lonmax,latmin,latmax,product,tseuil)

%+
%
%
% ==============
% plotimageMSG.m
% ==============
%
% .. function:: plotimageMSG(yyyy, mm, dd,timestep,lonmin,lonmax,latmin,latmax,product,tseuil)
%
% DESCRIPTION
% ===========
%
%   :param timestep: hour and minute
%   :type timestep: double
%   :raise timestep: required
%
%   :para mm: month of MSG data mm
%   :type mm: double
%   :raise mm: required
%
%   :para dd: day of MSG data dd
%   :type dd: double
%   :raise dd: required
%
%   :para timestep: month of MSG data timestep
%   :type timestep: double
%   :raise timestep: required
%
%   :param lonmin: longitude min, W < 0
%   :units lonmin: deg
%   :type lonmin: double
%   :raise lonmin: required
%
%   :param lonmax: longitude max, W < 0
%   :units lonmax: deg
%   :type lonmax: double
%   :raise lonmax: required
%
%   :param latmin: latitude min, N > 0
%   :units latmin: deg
%   :type latmin: double
%   :raise latmin: required
%
%   :param latmax: latitude max, N > 0
%   :units latmax: deg
%   :type latmax: double
%   :raise latmax: required
%
%   :param product: classif for classification, tb108 for temperature brillance 10.8
%   :type product: string
%   :raise product: required
%
%   :param tseuil: seuil de temprature de brillance
%   :units tseuil: K
%   :type tseuil: double
%   :raise tseuil: required
%
% +todo+ lit MSG NetCDF file in :file:`${PROJECT_ID}/MSG/{yyyy}/{mm}/`.
%
% +todo+ calcule
%
% +todo+ dessine
%
% EXAMPLES
% ========
%
% To plot temperature brillance 10.8 of MSG data on 2006-08-01 at time 00:00::
%
%  see demo 1
%
% SEE ALSO
% ========
%
% :ref:`data_msg`
%
% :ref:`varamma_startup.m`
%
% :func:`MSGread`
%
% TODO
% ====
%
% status de retour
%
% externalize reading (to make demo with simulation possible)
%
% check for missing values
%
% demo classif 
%
% demo simul
%
% get rid of mlint output
%
% check arguments
%
% replace timestep by hhmn
%
% date and time dans title
%
% save figure
%
% EVOLUTIONS
% ==========
%
% $Id: plotimageMSG.m 325 2011-08-04 15:30:01Z pinsard $
%
% $URL$
%
% - pinsard 2011-05-26T07:52:18Z loholt1.ipsl.polytechnique.fr
%
%   * image is a function (reserve word)
%
% - pinsard 2011-05-03T17:22:24Z loholt1.ipsl.polytechnique.fr (Linux)
%
%   * improve parameters
%   * use MSGread
%   * add demo
%
% - fplod 20110121T131304Z aedon.locean-ipsl.upmc.fr (Darwin)
%
%   * complement on header
%
% - fplod 20100726T123636Z aedon.locean-ipsl.upmc.fr (Darwin)
%
%   * files must be in ${PROJECT_ID}/MSG/yyyy/mm/
%
% - fplod 20100608T114448Z aedon.locean-ipsl.upmc.fr (Darwin)
%
%   * make it work running with matlab
%     no more ``Value must be a column or row vector``
%
% - fplod 20100604T094112Z aedon.locean-ipsl.upmc.fr (Darwin)
%
%   * minimize mlint output
%
% - fplod 20100604T083004Z aedon.locean-ipsl.upmc.fr (Darwin)
%
%   * add usage of varamma_startup : no more chemin parameter, PROJECT_ID value
%     used instead
%
% - fplod 20100525T124145Z aedon.locean-ipsl.upmc.fr (Darwin)
%
%   * add example
%
% - fplod 20100521T150917Z aedon.locean-ipsl.upmc.fr (Darwin)
%
%   * minimal header
%
% - lelod 20100521
%
%   * creation
%-
%global application;
%global PROJECT_OD;
%
z_deb=[latmin lonmin];
z_fin=[latmax lonmax];
[data, time, lon, lat, yyyy, mm, dd] = MSGread(num2str(yyyy,'%4.4d'), num2str(mm,'%2.2d'), num2str(dd,'%2.2d'));
%++ test si lecture ok

%switch product
%    case {'classif'}
    %trace image
%    la=find(lat(:)>z_deb(1) & lat(:)<z_fin(1));
%    lo=find(lon(:)>z_deb(2) & lon(:)<z_fin(2));
%    latit=lat(la);
%    longi=lon(lo);
    %trace image
%    my_image=0.01*squeeze(data(timestep,la,lo));
%    [x,y]=meshgrid(longi,latit);
%    figure(1)
%    switch application
%       case {'matlab'}
%          imagesc(longi,latit,my_image);
%       case {'octave'}
%          imagesc(x,y,my_image);
%       otherwise
%          error('unknown application running');
%    end
%    xlabel('longitude');
%    ylabel('latitude');
%    title('msg classif');
%    set(gca,'Ydir','reverse');
%    colorbar('WestOutside','YTickLabel',{'Terre claire','Mer claire','Bas cumul.','Bas non cumul.','Moyen cumul.','Moyen non cumul.','Haut cumul.','Haut non cumul.','Semi-transparent','Fractionne'},'fontsize',8);

%    case {'tb108' }
    %trace image
    la=find(lat(:)>z_deb(1) & lat(:)<z_fin(1));
    lo=find(lon(:)>z_deb(2) & lon(:)<z_fin(2));
    latit=lat(la);
    longi=lon(lo);
    imagemsg=squeeze(data(timestep,la,lo));
%    data_cloud=find(imagemsg < tseuil);
%    imagefin=imagemsg(data_cloud);
    [x,y]=meshgrid(longi,latit);
    figure(1)
%    switch application
%       case {'matlab'}
%          imagesc(longi,latit,imagemsg);
%       case {'octave'}
          imagesc(x,y,imagemsg);
%       otherwise
%          error('unknown application running');
%    end
    xlabel('longitude');
    ylabel('latitude');
    title('msg tb 108');
    set(gca,'Ydir','reverse');
    %colorbar('YTick',[1:1:10.5],'YTickLabel','fontsize',8);
    colorbar('WestOutside');
    %
    %nb de points froids
    'nombre de pixels de Tb < tseuil';
    a=find(imagemsg <tseuil);
    %pour avoir le nombre de pixels en-dessous du seuil pour une image
    nombrepixels=size(a);
end

%!demo
%! ! To plot temperature brillance 10.8 of MSG data on 2006-08-01 at the 1st time step::
%! clear all
%! varamma_startup
%! yyyy=2006;
%! mm=8;
%! dd=1;
%! timestep=1;
%! product='tb108';
%! tseuil=239;
%! lonmin=-20;
%! lonmax=-10;
%! latmin=10;
%! latmax=20;
%! [longi,latit,imagemsg]=plotimageMSG(yyyy, mm, dd,timestep,lonmin,lonmax,latmin,latmax,product,tseuil);
