function [result]=recup_camp(lon_value, lat_value, datestr_value, lai_value)

%RECUP_CAMP plot LAI from LAI array

%
%+
%
% =============
% recup_camp.m
% =============
%
% .. function:: recup_camp(lon_value, lat_value, datestr_value, lai_value)
%
% DESCRIPTION
% ===========
%
% ``recup_camp`` compute ++
%
% ``recup_camp`` plot ++
%
% Figure is saved  in :file:`${PROJECT_OD}/recup_camp_01.ps`.
%
% If time interval is more than one year -, only the first year of data
% will be plot
%
% CAUTIONS
% ========
%
% If matlab is running, Statistical Toolbox is needed because of
% usage of :func:`nanmean` and :func:`nanstd`.
%
% EXAMPLES
% ========
%
% Voir "demo".
%
% SEE ALSO
% ========
%
% :ref:`data_lai`
%
% :func:`simul_lai_2d`
% :func:`read_lai_2d`
%
% :func:`nanmean`
% :func:`nanstd`
%
% TODO
% ====
%
% outputs : std max, etc. to be plot and use in SIG
%
% jbfill is no a matlab or octave function : it has been found by soclod on website ++
% it should be moved to external_matlab. No rest documentation in this source : how to reference it ?
%
% jbfill effect not visible
%
% jbfill alernative
%
% remove ind_pt_fixes forcing
%
% return status
%
% avec la demo 1 (simu 1) pas de donnes trouves. soit changer la demo soit changer la simu.
%
% idem pour demo2 ... plus bizarre !
%
% demo3 mme avec forage des points selectionns pas de points sur la figure
%  ... bizarre !
%
% boite en parametre, selection boitre , rayon
%
% je n'arrive aps en jouant avc xmlin  voir "Dec yyyy" dans les labels x
%
% externalize boxes def.
%
% to do trace du lai durant toute la priode de l'tude c'est  dire de
% 2000  2008
%
% calcul pour les trois premiere annee et enregistrer et
% faire de meme pour les quatre derniere puis concatener les deux resultats
%
% check beahaviour with missing value (nanmean vs mean)
%
% externalize plot
%
% EVOLUTIONS
% ==========
%
% $Id$
%
% $URL$
%
% - fplod 20110630T143027Z aedon.locean-ipsl.upmc.fr (Darwin)
%
%   * usage of datetick for time x label even if not stricktly identical
%     behavior between octave and matlab
%
% - fplod 20110628T081030Z aedon.locean-ipsl.upmc.fr (Darwin)
%
%   * minimal rst header
%   * externalize LAI reading file (no more load file)
%   * add demo
%   * replace nan* by * runnunig octave because nanmean, etc do not exit
%     in octave
%   * xmin and xmax yyyyb0101, yyyyb1231
%   * save figure
%
% - soclod ??????
%
%   * creation cf. prsentation LPAO 201106
%     first commit revision 300
%
%-
global application;
global application_version;
global PROJECT_OD;
%
result=[];
;
nb_datestr=size(datestr_value,1);
;
lat=lat_value;
lon=lon_value;
%
%steppe herbacee arbustive

% ind_lon=find(-14.975<=lon&lon<=-14.911);
% ind_lat=find(15.579<=lat&lat<=15.629);
% ind_pt_fixes=find(-14.975<=lon&lon<=-14.911&15.579<=lat&lat<=15.629);

%steppe arbustive arboree

ind_lon=find(-14.768<=lon&lon<=-14.740);
ind_lat=find(15.137<=lat&lat<=15.163);
ind_pt_fixes=find(-14.768<=lon&lon<=-14.740&15.137<=lat&lat<=15.163);

% steppe herbacee arboree

% ind_lon=find(-14.423<=lon&lon<=-14.420);
% ind_lat=find(15.621<=lat&lat<=16.621);
% ind_pt_fixes=find(-14.423<=lon&lon<=-14.420&15.621<=lat&lat<=16.621);

% steppe herbacee

% ind_lon=find(-13.891<=lon&lon<=-13.873);
% ind_lat=find(15.721<=lat&lat<=15.729);
% ind_pt_fixes=find(-13.891<=lon&lon<=-13.873&15.721<=lat&lat<=15.729);

% savane arboree

% ind_lon=find(-13.671<=lon&lon<=-13.633);
% ind_lat=find(14.962<=lat&lat<=15.021);
% ind_pt_fixes=find(-13.671<=lon&lon<=-13.633&14.962<=lat&lat<=15.021);

% savane arbustive boisee

% ind_lon=find(-14.311<=lon&lon<=-14.284);
% ind_lat=find(15.529<=lat&lat<=15.546);
% ind_pt_fixes=find(-14.311<=lon&lon<=-14.284&15.529<=lat&lat<=15.546);

% % cultures

% ind_lon=find(-16.091<=lon&lon<=-16.064);
% ind_lat=find(15.613<=lat&lat<=15.637);
% ind_pt_fixes=find(-16.091<=lon&lon<=-16.064&15.613<=lat&lat<=15.637);

% savane arbustive

% ind_lon=find(-14.311<=lon&lon<=-14.230);
% ind_lat=find(15.379<=lat&lat<=15.429);
% ind_pt_fixes=find(-14.311<=lon&lon<=-14.230&15.379<=lat&lat<=15.429);

% savane arbustive arboree

% ind_lon=find(-15.239<=lon&lon<=-15.201);
% ind_lat=find(15.771<=lat&lat<=15.804);
% ind_pt_fixes=find(-15.239<=lon&lon<=-15.201&15.771<=lat&lat<=15.804);

% savane boisee

% ind_lon=find(-14.601<=lon&lon<=-14.546);
% ind_lat=find(15.921<=lat&lat<=15.962);
% ind_pt_fixes=find(-14.601<=lon&lon<=-14.546&15.921<=lat&lat<=15.962);

% plantation

% ind_lon=find(-15.187<=lon&lon<=-15.186);
% ind_lat=find(15.904<=lat&lat<=15.921);
% ind_pt_fixes=find(-15.187<=lon&lon<=-15.186&15.904<=lat&lat<=15.921);

% savane herbacee arbustive

% ind_lon=find(-15.344<=lon&lon<=-15.270);
% ind_lat=find(15.062<=lat&lat<=15.121);
% ind_pt_fixes=find(-15.344<=lon&lon<=-15.270&15.062<=lat&lat<=15.121);


ind_pt_fixes=1:size(lai_value,1);
disp([' www : forcage ind_pt_fixes pour map']);

if (isempty(ind_pt_fixes))
   error(['eee : no LAI points found'])
end

for index_datestr=1:nb_datestr;
  lai6_semaine_boite(:,index_datestr)=lai_value(ind_pt_fixes,index_datestr);
  switch application
      case {'matlab'}
          lai6_mean(:,index_datestr)=nanmean(lai6_semaine_boite(:,index_datestr));
          lai_std(:,index_datestr)=nanstd(lai6_semaine_boite(:,index_datestr));
      case {'octave'}
          lai6_mean(:,index_datestr)=mean(lai6_semaine_boite(:,index_datestr));
          lai_std(:,index_datestr)=std(lai6_semaine_boite(:,index_datestr));
      otherwise
          error('unknown application running');
  end
  p=5;
  aa6_moy=filter(ones(1,p)/p,1,lai6_mean);
  % lissage (moyenne glissante)
  aa_ecartype=filter(ones(1,p)/p,1,lai_std);
end

jbfill(1:361/48:361,aa6_moy+aa_ecartype,aa6_moy-aa_ecartype,[0.8 0.8 0.8],[1 1 1],.2)
% crocher 1 la couleur
%jbfill(1:361/48:361,aa_moy+ste(aa_moy),aa_moy-ste(aa_moy),[0.5 0.5 0.5],[1 1 1],.1)

%plot(lai_semaine_boite);
 %aa_moy=[aa0_moy(3:end) aa1_moy(3:end) aa2_moy(3:end) aa3_moy(3:end) aa4_moy(3:end) aa5_moy(3:end) aa6_moy(3:end) aa7_moy(3:end) aa8_moy(3:end)];% concatnation
%
% define xmin to the begining of the year and xmax to the end of the year
[yyyyb,mmb,ddb]=split_yyyymmdd(str2double(datestr_value(1,:)));
[yyyye,mme,dde]=split_yyyymmdd(str2double(datestr_value(end,:)));
if ( yyyyb ~= yyyye )
   disp(['www : only ' num2str(yyyyb) ' will be plot']);
end
xmin=datenum(yyyyb,1,1);
xmax=datenum(yyyyb,12,eomday(yyyyb,12));

hold on
xdata=datenum(datestr_value,'yyyymmdd');
plot(xdata,aa6_moy,'k-','linewidth',2);

ylim([0 3]);
xlabel('Date')
ylabel('LAI')
ax=gca;
set(ax,'xtick',datenum(yyyyb,1:2:12,1));
switch application
    case {'matlab'}
         datetick('x','mmmyyyy','keepticks');
    case {'octave'}
         datetick('mmm yyyy','keepticks');
    otherwise
        error('unknown application running');
end

xlim([xmin xmax]);
title('steppe arbustive arboree')
plot(xdata,aa_ecartype);
ylim([0.1 2]);
legend('std','mean lai');
grid('on');
%
% save figure
printer='ps';
print_printer=['-d', printer];
fullfilename=[PROJECT_OD, mfilename, '_01.', printer];
clear printer;
print(print_printer,fullfilename);
clear print_printer;
clear fullfilename;

result=1;

end

%!demo
%! % From scratch to create short array of LAI and associated arrays lat, long
%! % and datestr::
%! close all
%! clear all
%! varamma_startup
%! more off
%! index_simulation=int8(1);
%! [lon_value, lat_value, datestr_value, lai_value]=simul_lai_2d(index_simulation);
%! result=recup_camp(lon_value, lat_value, datestr_value, lai_value);

%!demo
%! % From scratch to create long array of LAI and associated arrays lat, long
%! % and datestr::
%! close all
%! clear all
%! varamma_startup
%! more off
%! index_simulation=int8(2);
%! [lon_value, lat_value, datestr_value, lai_value]=simul_lai_2d(index_simulation);
%! result=recup_camp(lon_value, lat_value, datestr_value, lai_value);

%!demo
%! % To plot LAI from :file:`${PROJECT_ID}/LAI/laisen2001_float.txt`::
%! close all
%! clear all
%! varamma_startup
%! more off
%! yyyy=int16(2001);
%! [lon_value, lat_value, datestr_value, lai_value]=read_lai_2d(yyyy);
%! result=recup_camp(lon_value, lat_value, datestr_value, lai_value);
