function [vecteurdatesamsu,imagesamsu,vecteurdatesmsg,imagesmsg]=selectionimages(cheminmsg,cheminamsu,lon1,lon2,lat1,lat2,mois1,jour1,heure1,mois2,jour2,heure2)

%SELECTIONIMAGES +todo+
%+
%
% =================
% selectionimages.m
% =================
%
% .. function:: selectionimages(cheminmsg,cheminamsu,lon1,lon2,lat1,lat2,mois1,jour1,heure1,mois2,jour2,heure2)
%
% DESCRIPTION
% ===========
% 
%   :param lon1: longitude min, W < 0
%   :units lon1: deg
%   :type lon1: double
%   :raise lon1: required
%
%   :param lon2: longitude max, W < 0
%   :units lon2: deg
%   :type lon2: double
%   :raise lon2: required
%
%   :param lat1: latitude min, N > 0
%   :units lat1: deg
%   :type lat1: double
%   :raise lat1: required
%
%   :param lat2: latitude max, N > 0
%   :units lat2: deg
%   :type lat2: double
%   :raise lat2: required
%
%   :param mois1: mois debut
%   :type mois1: int8
%   :raise mois1: required
%
%   :param jour1: jour debut
%   :type jour1: int8
%   :raise jour1: required
%
%   :param heure1: heure debut
%   :type heure1: int8
%   :raise heure1: required
%
%   :param mois2: mois fin
%   :type mois2: int8
%   :raise mois2: required
%
%   :param jour2: jour fin
%   :type jour2: int8
%   :raise jour2: required
%
%   :param heure2: heure fin
%   :type heure2: int8
%   :raise heure2: required
%
% EXAMPLES
% ========
%
% +todo+
% ::
%
%  octave> clear all
%  octave> varamma_startup
%  octave> more off
%  octave> lon1=-15;
%  octave> lon2=-10;
%  octave> lat1=15;
%  octave> lat2=20;
%  +todo+
%  octave> [vecteurdatesamsu,imagesamsu,vecteurdatesmsg,imagesmsg]=selectionimages(cheminmsg,cheminamsu,lon1,lon2,lat1,lat2,mois1,jour1,heure1,mois2,jour2,heure2)
%
% SEE ALSO
% ========
%
% :ref:`guide data MSG <data_msg>`
% :ref:`guide data AMSU <data_amsu>`
%
% :ref:`varamma_startup.m`
%
% TODO
% ====
%
% status de retour
%
% split reading and calculate and plot
%
% check argument
%
% usage of PROJECT_ID
%
% EVOLUTIONS
% ==========
%
% $Id: selectionimages.m 326 2011-08-05 14:24:46Z pinsard $
% 
% $URL$
%
% - fplod 20110121T135800Z aedon.locean-ipsl.upmc.fr (Darwin)
%
%   * minimal rst header
%
%-
lat1=10;
lat2=11;
lon1=-11;
lon2=-10;
cheminamsu='/net/zeus/usr/zeus/incas/mousson/AMSU/';
cheminmsg='/net/zeus/usr/zeus/incas/mousson/MSG/';
scale_factor=0.01;
offset=327.68;
indicedebut=200;
indicefin=210;

mois1=8;
mois2=8;
jour1=5;
jour2=7;
heure1=12;
heure2=12;

%calcul des indices de debut et de fin
date1=datenum(2006,mois1,jour1,heure1);
date2=datenum(2006,mois2,jour2,heure2);
cd(cheminamsu)
datafilesamsu=dir([cheminamsu 'amsu*']);
sizeamsu=size(datafilesamsu,1);
for i=1:sizeamsu
fich=datafilesamsu(i).name;
vecteurdatesamsu(i)=datenum(str2num(fich(17:20)),str2num(fich(21:22)),str2num(fich(23:24)),str2num(fich(26:27)),str2num(fich(28:29)),str2num(fich(30:31)));
end
[a,indicedebut]=min(abs(vecteurdatesamsu-date1));
[a,indicefin]=min(abs(vecteurdatesamsu-date2));



%lecture et enregistrement des dates et images AMSU


%definition du vecteur vecteurdatesamsu et de la matrice imagesamsu
sizeamsu=size(datafilesamsu,1);
vecteurdatesamsu=zeros(1,indicefin-indicedebut+1);

file=netcdf('amsubch5-noaa15_20060730-052728_afratl_Nadir.nc','nowrite');
lon=file{'lon'}(:);
lat=file{'lat'}(:);
[a,indicelat1]=min(abs(lat-lat1));
[a,indicelat2]=min(abs(lat-lat2));
[a,indicelon1]=min(abs(lon-lon1));
[a,indicelon2]=min(abs(lon-lon2));
close(file)
imagesamsu=zeros(indicefin-indicedebut+1,indicelat2-indicelat1+1,indicelon2-indicelon1+1);

%lecture des donnees amsu
for i=1:indicefin-indicedebut+1
fich=datafilesamsu(i).name;
vecteurdatesamsu(i)=datenum(str2num(fich(17:20)),str2num(fich(21:22)),str2num(fich(23:24)),str2num(fich(26:27)),str2num(fich(28:29)),str2num(fich(30:31)));
file=netcdf(datafilesamsu(i).name,'nowrite');
tb=file{'tbch5b'}(:);
tb=squeeze(tb);
imagesamsu(i,:,:)=tb(indicelat1:indicelat2,indicelon1:indicelon2);
close(file)
end

date1=datenum(2006,mois1,jour1,heure1);
date2=datenum(2006,mois2,jour2,heure2);
[a,indicedate1]=min(abs(vecteurdatesamsu-date1));
[a,indicedate2]=min(abs(vecteurdatesamsu-date2));

%classement des donnees amsu dans l ordre chronologique
[s,indices]=sort(vecteurdatesamsu);
imagesamsu=imagesamsu(indices,:,:);
vecteurdatesamsu=s;




%recherche des images MSG les plus proches temporellement des images AMSU
cd(cheminmsg)
datafilesmsg=dir([cheminmsg 'msg-tb108*']);

%definition des vecteurs jours et heures amsu, de la matrice imagesmsg, des vecteurs dates msg et jours msg 
vecteurjoursamsu=floor(vecteurdatesamsu);
vecteurheuresamsu=vecteurdatesamsu-vecteurjoursamsu;
sizemsg=size(datafilesmsg,1);
imagesmsg=zeros(indicefin-indicedebut+1,indicelat2-indicelat1+1,indicelon2-indicelon1+1);
vecteurdatesmsg=zeros(1,indicefin-indicedebut+1);

for i=1:sizemsg
fich=datafilesmsg(i).name;
vecteurjoursmsg(i)=datenum(str2num(fich(11:14)),str2num(fich(16:17)),str2num(fich(19:20)));
end


%lecture des donnees msg, remplissage des vecteurs dates msg et heures msg
for i=1:indicefin-indicedebut+1
i

jour=vecteurjoursamsu(i);
indicejour=find(vecteurjoursmsg == jour)

if (isempty(indicejour) == 0)

file=netcdf(datafilesmsg(indicejour).name,'nowrite');
time=file{'TIME'}(:);
vecteurheuresmsg=(time-time(1))/24;
heure=vecteurheuresamsu(i);
[a,indiceheure]=min(abs(vecteurheuresmsg-heure));
%indiceheure=find(abs(vecteurheuresmsg-heure)==min(abs(vecteurheuresmsg-heure)))

if ( min(abs(vecteurheuresmsg-heure)) < 0.25)
imagesmsg(i,:,:)=scale_factor*file{'DATA'}(indiceheure,indicelat1:indicelat2,indicelon1:indicelon2)+offset;
vecteurdatesmsg(i)=vecteurjoursmsg(indicejour)+vecteurheuresmsg(indiceheure);
end

close(file)

end

end


pos=find(vecteurdatesmsg == 0);
vecteurdatesmsg(pos)=[];
imagesmsg(pos,:,:)=[];

vecteurdatesamsu(pos)=[];
imagesamsu(pos,:,:)=[];

Tseuil1=280;   % on enleve les points chauds (surface)
Tseuil2=250;   % on enleve les points chauds (surface)
a=find((imagesmsg <Tseuil1) & (imagesamsu <Tseuil2));

plot(imagesamsu(a),imagesmsg(a),'+', 'markersize', 1)
xlabel('TbAMSU');
ylabel('TbMSG');


cd ..
save donnees-msg.oct vecteurdatesmsg imagesmsg
save donnees-amsu.oct vecteurdatesamsu imagesamsu
