%+
%
% .. _testInterp1D.m:
%
% ==============
% testInterp1D.m
% ==============
%
% DESCRIPTION
% ===========
%
% test interpolation EPSAT
%
% EXAMPLES
% ========
%
% see demo
%
% SEE ALSO
% ========
%
% :func:`varamma_startup.m`
%
% :func:`world_map`
%
% TODO
% ====
%
% usage of PROJECT_ID
%
% slection dans la boite pas ok. pour l'instant on voit tout le
% domaine. On utilisera inpolygon quand on aura spliter lecture/moulinette/plot
%
% - cratos  matlab R2010b
%
%   fix core  R2010b (/opt/matlab-2010b/matlab on cratos) with following line::
%
%     set(image,'alphadata',~isnan(PluieEPSAT(:,:,i)'));
%
% - cratos  octave 3.2.4
%
%   * handle  unknown property "alphadata" using octave 3.2.4 on cratos
%   * toketive outputs ann = ? and ::
%     warning: unknown option 'fminunc'
%     warning: unknown option 'fsolve'
%     warning: unknown option 'fzero'
%     warning: unknown option 'lsqnonneg'
%
% - zeus octave 3.0.2
%
%   ::
%
%     warning: set: invalid property `units'
%     warning: set: invalid property `position'
%     warning: set: invalid property `alphadata'
%
%     Invalid call to delete.  Correct usage is:
%
%      -- Function File:  delete (FILE)
%      -- Function File:  delete (H)
%
% - zeus matlab R2007a
%
%
% EVOLUTIONS
% ==========
%
% $Id$
%
% $URL$
%
% - fplod 20110301T113039Z aedon.locean-ipsl.upmc.fr (Darwin)
%
%   * point instead of line plot of coastline
%
% - fplod 20110225T172102Z aedon.locean-ipsl.upmc.fr (Darwin)
%
%   * test on zeus with octave 3.0.2. not so uggly.
%   * test on zeus with matlab R2007a. idem
%
% - fplod 20110225T165937Z aedon.locean-ipsl.upmc.fr (Darwin)
%
%   * minimal modif to be used on cratos with octave 3.2.4 :
%     world map cmgco_traitdecote.mat (need varamma_startup)
%   * add demo (even if uggly)
%
% - fplod 20110225T161413Z aedon.locean-ipsl.upmc.fr (Darwin)
%
%   * minimal modif to be used on cratos with matlab R2007a :
%     path of dataset, netcdf reading tools
%
%-
latmin = 10;
latmax = 20;
lonmin = -20;
lonmax = -10;

%repertoire = 'C:\Users\Jas\Desktop\Documents de Travail\S6\Stage au labo LOCEAN\Matlab\EPSAT\';
repertoire = '/net/zeus/usr/zeus/incas/mousson/';
path(path,repertoire);

ext = '*.nc';
chemin = fullfile(repertoire,ext);
liste = dir(chemin);
nbjour = numel(liste);

num_jour=2;

fichier = [repertoire liste(num_jour).name];

%%%%%%%%%%%%%%%%%%%%%%%%%%
%
% Rcupration des donnes
%
%%%%%%%%%%%%%%%%%%%%%%%%%%

% Ouverture du fichier netCDF.
ncid = netcdf(fichier, 'nowrite');

% Rcupration des variables.
Temps = ncid{'time'}(:);
Latitudes = ncid{'lat'}(:);
Longitudes = ncid{'lon'}(:);

% On cherche la premiere et le nombre de latitude/longitude  prendre
% en compte d'aprs notre domaine d'tude prcdemment dfinit.
startlat = find(Latitudes >= latmin, 1 );
countlat = find(Latitudes <= latmax, 1, 'last' ) - startlat + 1;
startlon = find(Longitudes >= lonmin, 1 );
countlon = find(Longitudes <= lonmax, 1, 'last' ) - startlon + 1;

% Restriction des donnes de lat/long  notre domaine.
Latitudes = Latitudes(Latitudes>=latmin & Latitudes<=latmax);
Longitudes = Longitudes(Longitudes>=lonmin & Longitudes<=lonmax);

% Rcupration des donnes EPSAT.
% orig jc
% PluieEPSAT = netcdf.getVar(ncid,11,[startlon-1 startlat-1 0],...
%    [countlon countlat size(Temps,1)]);
surface_rainrate=ncid{'data'}(:);
%whos surface_rainrate
%
% selection of precipitation inside the box +todo+ pas ok
%++PluieEPSAT=surface_rainrate(:,startlon-1:startlon-1+countlon,startlat-1:startlat-1+countlat);
PluieEPSAT=surface_rainrate;
%whos PluieEPSAT

load('cmgco_traitdecote.mat','Xgco','Ygco');

PluieEPSAT = double(PluieEPSAT);

% On modifie l'ordre des dimensions pour mettre le temps en premier.
M_PluieEPSAT = permute(PluieEPSAT,[3 1 2]);

% On cherche pour quels temps on a des absences de donnes (o on a
% -1).
AbsDonnees = find(M_PluieEPSAT(:,1,1)==-1);

% x est la variable contenant les diffrents temps que l'on doit
% garder puisque nous avons des valeurs.
x = 1 : size(M_PluieEPSAT,1);
x(AbsDonnees) = 0;
x = x(x~=0);

% On supprime, dans la matrice de donnes, les valeurs manquantes.
for i = 1 : size(AbsDonnees,1)
    M_PluieEPSAT(AbsDonnees(size(AbsDonnees,1)-(i-1)),:,:) = [];
end

% On interpole pour avoir l'ensemble des pas de temps.
M_PluieEPSAT = double(M_PluieEPSAT);
M_PluieEPSAT = interp1(x,M_PluieEPSAT,1:size(PluieEPSAT,3));

% On remet les dimensions dans leur ordre initial.
PluieEPSAT2 = permute(M_PluieEPSAT,[2 3 1]);

set(gcf,'color','w','units','normalized','position',[0 0 1 1]);

PluieEPSAT(PluieEPSAT==0)=NaN;
PluieEPSAT2(PluieEPSAT2==0)=NaN;

for i = 1 : size(Temps,1);

    subplot(1,2,1);
    image = imagesc(Longitudes,Latitudes,PluieEPSAT(:,:,i)');
    set(image,'alphadata',~isnan(PluieEPSAT(:,:,i)'));
    axis([lonmin lonmax latmin latmax])
    hold on
    set(gca,'ydir','normal')
    coast = plot(Xgco,Ygco,'k.');
    Title = title('Donnes originelles');
    xlabel('Longitudes')
    ylabel('Latitudes')
    grid on
    ticklatlon

    subplot(1,2,2);
    image2 = imagesc(Longitudes,Latitudes,PluieEPSAT2(:,:,i)');
    set(image2,'alphadata',~isnan(PluieEPSAT2(:,:,i)'));
    axis([lonmin lonmax latmin latmax])
    hold on
    set(gca,'ydir','normal')
    coast2 = plot(Xgco,Ygco,'k.');
    Title2 = title('Donnes avec interpolations');
    xlabel('Longitudes')
    ylabel('Latitudes')
    grid on
    ticklatlon

    pause(0.2)
    delete(image,image2)

end
%
%!demo
%! close all
%! varamma_startup
%! testInterp1D
